"""
DO NOT EDIT THIS FILE!!
This file is automatically generated by the process_schemas.py program
in the scripts directory. It is not intended to be edited directly. If
you need to update the GEL protocol classes, please run the script
on the appropriate schema version.
"""
from protocols.protocol import (
    ProtocolElement,
    avro_parse,
    load_schema,
)


class Publication(ProtocolElement):
    """
    For each publication, either a PMID or DOI should be included,
    preferably both if available
    """

    # load schema from file
    _schemaSource = load_schema(__file__)
    # parse into avro classes
    schema = avro_parse(_schemaSource)

    requiredFields = {}

    @classmethod
    def getEmbeddedTypes(cls):
        # import here to prevent circular imports in python 2.7.
        from protocols.protocol_7_13 import reports as reports_6_5_0

        return {
            "comments": reports_6_5_0.UserComment,
        }

    @classmethod
    def getEmbeddedEnums(cls):
        return {}

    @classmethod
    def getEmbeddedByNamespace(cls):
        # import here to prevent circular imports in python 2.7.
        from protocols.protocol_7_13 import reports as reports_6_5_0

        return {
            "org.gel.models.report.avro.UserComment": reports_6_5_0.UserComment,
            "org.gel.models.report.avro.Publication": reports_6_5_0.Publication,
        }

    __slots__ = [
        "comments",
        "doi",
        "pmid",
    ]

    def __init__(
        self,
        comments=None,
        doi=None,
        pmid=None,
        validate=None,
        **kwargs
    ):
        """Initialise the reports_6_5_0.Publication model.

        :param comments:
            User comments left on this article as part of this variant
            interpretation
        :type comments: None | list[UserComment]
        :param doi:
            Digital Object Identifier (DOI) e.g. 10.1056/NEJMra0802968
        :type doi: None | str
        :param pmid:
            PubMed ID
        :type pmid: None | str
        """

        attributes = {k: v for k, v in locals().items() if k not in ["self", "unknown"]}
        ProtocolElement.__init__(self, **attributes)

    @classmethod
    def _namespace_version(cls):
        return "6.5.0"
